OGRE-Next: Ogre::v1::NumericAnimationTrack Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::v1::NumericAnimationTrack Class Reference
Core » Animation

Specialised AnimationTrack for dealing with generic animable values. More...

`#include <OgreAnimationTrack.h>`

Inheritance diagram for Ogre::v1::NumericAnimationTrack:
[legend]

## Public Member Functions
| NumericAnimationTrack (Animation *parent, unsigned short handle)
| Constructor.
| NumericAnimationTrack (Animation *parent, unsigned short handle, AnimableValuePtr &target)
| Constructor, associates with an AnimableValue.
NumericAnimationTrack * | _clone (Animation *newParent) const
| Clone this track (internal use only).
void | apply (const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f) override
| Applies an animation track to the designated target.
void | applyToAnimable (const AnimableValuePtr &anim, const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f)
| Applies an animation track to a given animable value.
virtual NumericKeyFrame * | createNumericKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
virtual const AnimableValuePtr & | getAssociatedAnimable () const
| Returns a pointer to the associated animable object (if any).
void | getInterpolatedKeyFrame (const TimeIndex &timeIndex, KeyFrame *kf) const override
| Gets a KeyFrame object which contains the interpolated transforms at the time index specified.
NumericKeyFrame * | getNumericKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
virtual void | setAssociatedAnimable (const AnimableValuePtr &val)
| Sets the associated animable object which will be automatically affected by calls to 'apply'.
Public Member Functions inherited from Ogre::v1::AnimationTrack
| AnimationTrack (Animation *parent, unsigned short handle)
| Constructor.
virtual | ~AnimationTrack ()
virtual void | _applyBaseKeyFrame (const KeyFrame *base)
| Internal method to re-base the keyframes relative to a given keyframe.
virtual void | _buildKeyFrameIndexMap (const vector< Real >::type &keyFrameTimes)
| Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.
virtual void | _collectKeyFrameTimes (vector< Real >::type &keyFrameTimes)
| Internal method to collect keyframe times, in unique, ordered format.
virtual void | _keyFrameDataChanged () const
| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.
virtual KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
unsigned short | getHandle () const
| Get the handle associated with this track.
virtual KeyFrame * | getKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
virtual Real | getKeyFramesAtTime (const TimeIndex &timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.
virtual unsigned short | getNumKeyFrames () const
| Returns the number of keyframes in this animation.
Animation * | getParent () const
| Returns the parent Animation object for this track.
virtual bool | hasNonZeroKeyFrames () const
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.
virtual void | optimise ()
| Optimise the current track by removing any duplicate keyframes.
virtual void | removeAllKeyFrames ()
| Removes all the KeyFrames from this track.
virtual void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index.
virtual void | setListener (Listener *l)
| Set a listener for this track.

## Detailed Description

Specialised AnimationTrack for dealing with generic animable values.

## Constructor & Destructor Documentation

## ◆ NumericAnimationTrack() [1/2]

Ogre::v1::NumericAnimationTrack::NumericAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle )

Constructor.

Referenced by _clone().

## ◆ NumericAnimationTrack() [2/2]

Ogre::v1::NumericAnimationTrack::NumericAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | AnimableValuePtr & | target )

Constructor, associates with an AnimableValue.

## Member Function Documentation

## ◆ _clone()

NumericAnimationTrack * Ogre::v1::NumericAnimationTrack::_clone | ( | Animation * | newParent | ) | const

Clone this track (internal use only).

References NumericAnimationTrack().

## ◆ apply()

void Ogre::v1::NumericAnimationTrack::apply | ( | const TimeIndex & | timeIndex,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )
| overridevirtual

Applies an animation track to the designated target.

Parameters

  timeIndex | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

Implements Ogre::v1::AnimationTrack.

## ◆ applyToAnimable()

void Ogre::v1::NumericAnimationTrack::applyToAnimable | ( | const AnimableValuePtr & | anim,
|  | const TimeIndex & | timeIndex,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )

Applies an animation track to a given animable value.

Parameters

  anim | The AnimableValue to which to apply the animation
  timeIndex | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

## ◆ createNumericKeyFrame()

virtual NumericKeyFrame * Ogre::v1::NumericAnimationTrack::createNumericKeyFrame | ( | Real | timePos | ) |
| virtual

Creates a new KeyFrame and adds it to this animation at the given time index.

Remarks
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters

  timePos | The time from which this KeyFrame will apply.

## ◆ getAssociatedAnimable()

virtual const AnimableValuePtr & Ogre::v1::NumericAnimationTrack::getAssociatedAnimable | ( |  | ) | const
| virtual

Returns a pointer to the associated animable object (if any).

## ◆ getInterpolatedKeyFrame()

void Ogre::v1::NumericAnimationTrack::getInterpolatedKeyFrame | ( | const TimeIndex & | timeIndex,
|  | KeyFrame * | kf ) const
| overridevirtual

Gets a KeyFrame object which contains the interpolated transforms at the time index specified.

Remarks
  The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters

  timeIndex | The time (in relation to the whole animation sequence)
  kf | Keyframe object to store results

Implements Ogre::v1::AnimationTrack.

## ◆ getNumericKeyFrame()

NumericKeyFrame * Ogre::v1::NumericAnimationTrack::getNumericKeyFrame | ( | unsigned short | index | ) | const

Returns the KeyFrame at the specified index.

## ◆ setAssociatedAnimable()

virtual void Ogre::v1::NumericAnimationTrack::setAssociatedAnimable | ( | const AnimableValuePtr & | val | ) |
| virtual

Sets the associated animable object which will be automatically affected by calls to 'apply'.

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h